//############################################################################
//
// LaserBoy !!!
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#include "ez_uail.hpp"

//############################################################################
void ez_uail::clear_unused_palettes()
{
    int              i,
                     j;                   
    ez_palette_set   palettes_in_use;
    //------------------------------------------------------------------------
    for(i = EZ_UAIL_DEFAULT; i < EZ_BUILT_IN_PALETTES; i++)
    {
        palette_picker(i).index  = i;
        palette_picker(i).in_use = true;
        palettes_in_use += palette_picker(i);
    }
    //------------------------------------------------------------------------
    for(i = EZ_BUILT_IN_PALETTES; i < number_of_palettes(); i++)
    {
        palette_picker(i).index  = i;
        palette_picker(i).in_use = false;
    }
    //------------------------------------------------------------------------
    for(j = 0; j < number_of_frames(); j++)
        palette_picker(frame_picker(j).palette_index).in_use = true;
    //------------------------------------------------------------------------
    for(i = 0; i < number_of_palettes(); i++)
    {
        if(palette_picker(i).in_use)
            palettes_in_use += palette_picker(i);
    }
    //------------------------------------------------------------------------
    for(i = 0; i < palettes_in_use.number_of_palettes(); i++)
    {
        for(j = 0; j < number_of_frames(); j++)
        {
            if(frame_picker(j).palette_index == palettes_in_use[i].index)
                frame_picker(j).palette_index = i;
        }
    }
    replace_palette_set(palettes_in_use);
    //------------------------------------------------------------------------
    return;
}

//############################################################################
void ez_uail::sync_rgb_and_palette()
{
    int             i                         = 0          ,
                    j                                      ,
                    super_palette_first_frame = 0          ,
                    super_palette_last_frame  = 0          ,
                    current_frame_index       = frame_index;
    ez_palette_set  reduced_palette_set                    ;
    ez_palette      super_palette                          ;
    char            super_palette_name[7]                  ;

    for(j = 0; j < number_of_frames(); j++)
        frame(j).sync_rgb_and_palette();
    //------------------------------------------------------------------------
    while(i < number_of_frames())
    {
        if(const_frame_picker(i).palette_index != EZ_TRUE_COLOR)
        {
            //----------------------------------------------------------------
            super_palette_first_frame = i;
            super_palette = palette_picker(const_frame_picker(i).palette_index);
            sprintf(super_palette_name, "%06d", new_super_palette_id);
            super_palette.name = string("SP") + super_palette_name;
            new_super_palette_id++;
            //----------------------------------------------------------------
            while(    i < number_of_frames()
                   && super_palette.unite(palette_picker(const_frame_picker(i).palette_index))
                 )
            i++;
            //----------------------------------------------------------------
            reduced_palette_set.push_back(super_palette);
            super_palette_last_frame  = i - 1;
            //----------------------------------------------------------------
            for(j = super_palette_first_frame; j <= super_palette_last_frame; j++)
            {
                frame(j).find_rgb_in_palette(super_palette);
                frame(j).palette_index = reduced_palette_set.number_of_palettes() - 1;
            }
            //----------------------------------------------------------------
        }
        else
            i++;
    }
    //------------------------------------------------------------------------
    frame(current_frame_index);
    replace_palette_set(reduced_palette_set);
    palette_index = current_frame().palette_index;
    return;
}

//############################################################################
void ez_uail::best_reduce_all_to_palette()
{
    int         i = 0;
    ez_palette  super_palette;
    char        super_palette_name[7];
    //------------------------------------------------------------------------
    for(i = 0; i < number_of_frames(); i++)
    {
        if(const_frame_picker(i).palette_index == EZ_TRUE_COLOR)
            const_frame_picker(i).best_reduce_to_palette();

        super_palette += palette_picker(const_frame_picker(i).palette_index);
    }
    //------------------------------------------------------------------------
    super_palette.best_reduction();
    //------------------------------------------------------------------------
    sprintf(super_palette_name, "%06d", new_super_palette_id);
    super_palette.name = string("SP") + super_palette_name;
    //------------------------------------------------------------------------
    new_super_palette_id++;
    push_back_palette(super_palette);
    //------------------------------------------------------------------------
    best_match_palette(ez_palette_set::size() - 1);
    //------------------------------------------------------------------------
    return;
}

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
