//############################################################################
//
// LaserBoy !!!
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#include "ez_uail_gui.hpp"
    
//############################################################################
int ez_uail_header::from_ifstream_ilda(ifstream&  in)
{
    int         i;
    char        a, b;
    //------------------------------------------------------------------------
    name.erase    ();
    owner.erase   ();
    //------------------------------------------------------------------------
    if(!in.eof())
    {
        in.get(a); if(a != 'I') return EZ_UAIL_BAD_HEADER;
        in.get(a); if(a != 'L') return EZ_UAIL_BAD_HEADER;
        in.get(a); if(a != 'D') return EZ_UAIL_BAD_HEADER;
        in.get(a); if(a != 'A') return EZ_UAIL_BAD_HEADER;
        in.get(a); if(a !=  0 ) return EZ_UAIL_BAD_HEADER;
        in.get(a); if(a !=  0 ) return EZ_UAIL_BAD_HEADER;
        in.get(a); if(a !=  0 ) return EZ_UAIL_BAD_HEADER;

        in.get(format);

        for(i = 0; i < 8; i++)
        {
            in.get(a);
            name += a;
        }

        for(i = 0; i < 8; i++)
        {
            in.get(a);
            owner += a;
        }

        in.get(a);    in.get(b);
        quantity = ((a & 0x00ff) << 8 | (b & 0x00ff));

        in.get(a);    in.get(b);
        identity = ((a & 0x00ff) << 8 | (b & 0x00ff));

        in.get(a);    in.get(b);
        total    = ((a & 0x00ff) << 8 | (b & 0x00ff));

        in.get(scanner);
        in.get(future) ;
    }
    //------------------------------------------------------------------------
    return in.bad();
}

//############################################################################
void ez_uail_header::to_ofstream_ilda(ofstream& out)
{
    int i;
    //------------------------------------------------------------------------
    out.put('I');
    out.put('L');
    out.put('D');
    out.put('A');
    out.put( 0 );
    out.put( 0 );
    out.put( 0 );
    //------------------------------------------------------------------------
    if(AIL->dumb_file_format)
    {
        if(format == EZ_UAIL_3D_VECTOR)
            format = EZ_UAIL_3D_COLOR_VECTOR;
        else if(format == EZ_UAIL_2D_VECTOR)
            format = EZ_UAIL_2D_COLOR_VECTOR;
    }
    out.put(format);
    //------------------------------------------------------------------------
    for(i = 0; i < 8; i++)
        out.put(name[i]);

    for(i = 0; i < 8; i++)
        out.put(owner[i]);

    out.put((char)((quantity & 0xff00) >> 8));
    out.put((char) (quantity & 0x00ff)      );

    out.put((char)((identity & 0xff00) >> 8));
    out.put((char) (identity & 0x00ff)      );

    out.put((char)((total    & 0xff00) >> 8));
    out.put((char) (total    & 0x00ff)      );

    out.put(scanner);
    out.put(future) ;
    //------------------------------------------------------------------------
    return;
}

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
